@echo off
if exist %~p1setFastbootMenu.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:diyMenu
@title %title% %version% - DIY Menu
color f9
    echo.--------------------------------------------------------------------------------
    echo. [1] Erase partition                           [2] Flash partition
    echo.
    echo. [3] Exit flash tool, Manually execute fastboot commands
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo.--------------------------------------------------------------------------------
    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && call :diyErase
        if "%input%"=="2" cls && call :diyFlash
        if "%input%"=="3" cls && call :diyByMe
        if "%input%"=="0" cls && exit /b 0
    cls
goto :diyMenu
::
::
:diyErase
@title %title% %version% - DIY Menu ( Erase Partition )
    echo.
    echo. ================================================================================
    echo.     Usage:
    echo. ================================================================================
    echo. [*] Enter the partition name directly, and press Enter.
    echo.
    echo.-------------------------------------------------------------------------------

    set partition=
    set /p partition= Please enter the partition name: ^>^>%=%
        if "%partition%"=="" (
            echo. Input error, please try again.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :diyErase
        )

    call "%~dp0enumerateFbDevices.cmd"

    echo.
    echo. Executing: fastboot erase %partition%
    %fastboot% erase %partition%
    REM Initialize the variable to 0.
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%fastboot% erase %partition%  2^>^&1`) do (
        echo. %%X

        for /F "usebackq tokens=1" %%C in (`echo. %%X ^| find /C "OKAY"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    if %okay_count% NEQ 1 (
        color f6
        echo. ---------------------------
        echo. Error: erase %partition% failed!
        echo. ---------------------------
        ping 127.0.1 -n 3 >nul 2>nul
        exit /b 1
    )

    echo.
    echo. Erase operation completed. Press any key to return to the DIY menu.
    pause > nul
exit /b 0
::
::
:diyFlash
@title %title% %version% - DIY Menu ( Flash partition )
    echo.
    echo. ================================================================================
    echo.  Usage:
    echo. ================================================================================
    echo. [*] Please enter the name of this partition first, and then enter the image
    echo. [*] location path (You can directly drag the image to this window).
    echo. [*] The directory name cannot contain spaces or special characters!
    echo.
    echo. -------------------------------------------------------------------------------
    echo.
    echo. [-] Note: Please enter the name of the partition to be flashed.
    echo.
    set partition=
    set /p partition= Please enter the partition name: ^>^>
        if "%partition%"=="" (
            echo. Input error, please try again.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :diyFlash
        )
    echo.
    echo. [-] Note: Please enter the image location path, or directly drag the image to this window.
    echo.
    set /p imglocation= Please enter the image location path: ^>^>

    call "%~dp0enumerateFbDevices.cmd"

    echo.
    echo. Executing: fastboot flash %partition% %imglocation%

    REM Initialize the variable to 0.
    set /A okay_count=0
    set /A send_write_count=0

    for /F "tokens=*" %%X in (' %fastboot% flash %partition% %imglocation% 2^>^&1 ') do (
        echo. %%X
        for /F "usebackq tokens=1" %%C in (`echo %%X ^| find /C "OKAY"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
        for /F "usebackq tokens=1" %%C in (`echo %%X ^| find /C "sending"`) do (
            if "%%C" == "1" set /A send_write_count+=1
        )
        for /F "usebackq tokens=1" %%C in (`echo %%X ^| find /C "writing"`) do (
            if "%%C" == "1" set /A send_write_count+=1
        )
    )
    if %okay_count% LSS 2 (
        color f6
        echo. ---------------------------
        echo. Error: fastboot flash %partition% failed!
        echo. ---------------------------
        echo. Please check the error, then press any key to return to the DIY menu.
        pause > nul
        exit /b 1
    )

    if %okay_count% NEQ %send_write_count% (
        color f6
        echo. ---------------------------
        echo. Error: fastboot flash %partition%  failed!
        echo. ---------------------------
        echo. Please check the error, then press any key to return to the DIY menu.
        pause > nul
        exit /b 1
    )

    echo.
    echo. Flash completed. Press any key to return to the DIY menu.
    pause > nul
exit /b 0
::
::
:diyByMe
    if exist "%TFS_ROOT%tools\cmd.bat" (
        start "" "%TFS_ROOT%tools\cmd.bat"
    ) else (
        color fc
        echo. Fatal Error: cmd.bat does not exist!
        ping 127.0.1 -n 2 >nul 2>nul
    )
exit
