@echo off
if exist %~p1doFlashAPart.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:doFlashAPPart
    if "%device_has_bluetooth%" EQU "1" (
        if exist BTFM.bin (
            echo.
            echo. ------ Flashing Bluetooth image ------
            %fastboot% flash bluetooth BTFM.bin
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash bluetooth failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: Bluetooth image does not exist, but your device contain this partition, skipping flash.
        )
    )

    REM This is a discriminant for dsp image.
    set /A A=0
    if exist adspso.bin set /A A+=1
    if exist dspso.bin set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: adspso.bin and dspso.bin exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: BP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_dsp!" EQU "1" (
            echo.
            echo. Warning: DSP image does not exist, but your device contain this partition, skipping flash.
        )
    )
    REM if %A% EQU 1
    if exist adspso.bin (
        echo.
        echo. ------ Flashing DSP image ------
        %fastboot% flash dsp adspso.bin
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash dsp failed!
            echo. ------------------------------
        )
    ) else (
        if exist dspso.bin (
            echo.
            echo. ------ Flashing DSP image ------
            %fastboot% flash dsp dspso.bin
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash dsp failed!
                echo. ------------------------------
            )
        )
    )

    if "%device_has_spmfw%" EQU "1" (
        if exist spmfw.img (
            echo.
            echo. ------ Flashing SPMFW image ------
            %fastboot% flash spmfw spmfw.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash spmfw failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: SPMFW image does not exist. Skipping flash...
        )
    )

    if "%device_has_scp%" EQU "1" (
        if exist scp.img (
            echo.
            echo. ------ Flashing SCP image ------
            %fastboot% flash scp scp.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash scp failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: SCP image does not exist. Skipping flash...
        )
    )

    if "%device_has_sspm%" EQU "1" (
        if exist sspm.img (
            echo.
            echo. ------ Flashing SSPM image ------
            %fastboot% flash sspm sspm.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash sspm failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: SSPM image does not exist. Skipping flash...
        )
    )

    if "%device_has_cam_vpu1%" EQU "1" (
        if exist cam_vpu1.img (
            echo.
            echo. ------ Flashing cam_vpu1 image ------
            %fastboot% flash cam_vpu1 cam_vpu1.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu1 failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: cam_vpu1 image does not exist. Skipping flash...
        )
        if exist cam_vpu2.img (
            echo.
            echo. ------ Flashing cam_vpu2 image ------
            %fastboot% flash cam_vpu2 cam_vpu2.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu2 failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: cam_vpu2 image does not exist. Skipping flash...
        )
        if exist cam_vpu3.img (
            echo.
            echo. ------ Flashing cam_vpu3 image ------
            %fastboot% flash cam_vpu3 cam_vpu3.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash cam_vpu3 failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: cam_vpu3 image does not exist. Skipping flash...
        )
    )

    if exist logo.bin (
        echo.
        echo. ------ Flashing Logo image ------
        %fastboot% flash logo logo.bin
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash logo failed!
            echo. ------------------------------
        )
    ) else (
        echo.
        echo. Note: Logo image does not exist. Skipping flash...
    )

    if "%device_has_vbmeta%" EQU "1" (
        if exist vbmeta.img (
            echo.
            echo. ------ Flashing VBMeta image ------
            %fastboot% flash vbmeta vbmeta.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash vbmeta failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Note: VBMeta image does not exist. Skipping flash...
        )
    )

    if exist boot.img (
        echo.
        echo. ------ Flashing Boot image ------
        %fastboot% flash boot boot.img
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash boot failed!
            echo. ------------------------------
        )
    ) else (
        echo.
        echo. Warning: Boot image does not exist. This is obviously wrong, please check!
    )

    if "%device_has_dtb%" EQU "1" (
        if exist dtb.img (
            echo.
            echo. ------ Flashing DTB image ------
            %fastboot% flash dtb dtb.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash dtb failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: DTB image does not exist, but your device contain this partition, skipping flash...
        )
    )

    if "%device_has_dtbo%" EQU "1" (
        if exist dtbo.img (
            echo.
            echo. ------ Flashing DTBO image ------
            %fastboot% flash dtbo dtbo.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash dtbo failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: DTBO image does not exist, but your device contain this partition, skipping flash...
        )
    )

    if "%device_has_recovery%" EQU "1" (
        if exist recovery.img (
            echo.
            echo. ------ Flashing Recovery image ------
            %fastboot% flash recovery recovery.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash recovery failed!
                echo. ------------------------------
            )
        ) else (
            echo.
            echo. Warning: Recovery image does not exist, but your device contain this partition, skipping flash...
        )
    )

    REM This is a discriminant for system image.
    set /A A=0
    if exist system.img set /A A+=1
    if exist super.img set /A A+=1
    if exist system.img_sparsechunk* set /A A+=1
    if exist super.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Different formats System / Super image exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        color fc
        echo.
        echo. Fatal Error: System image or Super image does not exist. This is obviously wrong, please check the firmware location path!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist system.img_sparsechunk* (
        echo.
        echo. ------ Flashing sparse System image ------
        REM Initialize the variable to 0.
        set flash_failed=0
        for %%a in (system.img_sparsechunk*) do (
            echo.
            echo. ==^> Flashing sparse System image: %%a
            %fastboot% flash system %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo. ------------------------------
                echo. Fatal Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            echo.
            echo. Error: AP flash failed!
            exit /b 1
        )
    ) else (
        if exist system.img (
            echo.
            echo. ------ Flashing full System image ------
            %fastboot% flash system system.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash system failed!
                echo. ------------------------------
                echo.
                echo. Error: AP flash failed!
                exit /b 1
            )
        )
    )

    if exist super.img_sparsechunk* (
        echo.
        echo. ------ Flashing sparse Super image ------
        REM Initialize the variable to 0.
        set flash_failed=0
        for %%a in (super.img_sparsechunk*) do (
            echo.
            echo. ==^> Flashing sparse Super image: %%a
            %fastboot% flash super %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo. ------------------------------
                echo. Fatal Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            echo.
            echo. Error: AP flash failed!
            exit /b 1
        )
    ) else (
        if exist super.img (
            echo.
            echo. ------ Flashing full Super image ------
            %fastboot% flash super super.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash super failed!
                echo. ------------------------------
                echo.
                echo. Error: AP flash failed!
                exit /b 1
            )
        )
    )

    REM This is a discriminant for system_b image.
    set /A A=0
    if exist system_other.img set /A A+=1
    if exist system_b.img_sparsechunk* set /A A+=1
    if exist system_other.img_sparsechunk.* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Full System_B and sparse System_B image exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_ab_slot!" EQU "1" (
            echo.
            echo. Note: Full or sparse System_B image does not exist, but your device contain this partition, skipping flash...
        )
    )
    if %A% EQU 1 (
        if "!device_ab_slot!" EQU "0" (
            color fc
            echo.
            echo. Fatal Error! You device not support slot A/B partition, why put System_B image into flash tool?
            echo.
            echo. Error: AP flash failed!
            exit /b 1
        )
    )

    REM if %A% EQU 1
    if exist system_b.img_sparsechunk.* (
        echo.
        echo. ------ Flashing sparse System_B image ------
        for %%a in (system_b.img_sparsechunk.*) do (
            echo.
            echo. ==^> Flashing sparse System_B image: %%a
            %fastboot% flash system_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
    )
    if exist system_other.img_sparsechunk.* (
        echo.
        echo. ------ Flashing sparse System_B image ------
        for %%a in (system_other.img_sparsechunk.*) do (
            echo.
            echo. ==^> Flashing sparse System_B image: %%a
            %fastboot% flash system_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
    )
    if exist system_other.img (
        echo.
        echo. ------ Flashing full System_B image ------
        %fastboot% flash system_b system_other.img
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash system_b failed!
            echo. ------------------------------
        )
    )

    REM This is a discriminant for oem image.
    set /A A=0
    if exist oem.img set /A A+=1
    if exist oem.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Full and sparse Oem image exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_oem!" EQU "1" (
            echo.
            echo. Note: Full or sparse Oem image Oem image does not exist, but your device contain this partition, skipping flash...
        )
    )

    REM if %A% EQU 1
    if exist oem.img_sparsechunk* (
        echo.
        echo. ------ Flashing sparse Oem image ------
        for %%a in (oem.img_sparsechunk*) do (
            echo.
            echo. ==^> Flashing sparse Oem image: %%a
            %fastboot% flash oem %%a
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
    ) else (
        if exist oem.img (
            echo.
            echo. ------ Flashing full Oem image ------
            %fastboot% flash oem oem.img
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash oem failed!
                echo. ------------------------------
            )
        )
    )

    REM This is a discriminant for oem_b image.
    set /A A=0
    if exist oem_other.img set /A A+=1
    if exist oem_b.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Full and sparse Oem_B image exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_oem!" EQU "1" (
            if "!device_ab_slot!" EQU "1" (
                echo.
                echo. Note: Full or sparse Oem_B image does not exist, but your device contain this partition, skipping flash...
            )
        )
    )
    if %A% EQU 1 (
        if "!device_ab_slot!" EQU "0" (
            color fc
            echo.
            echo. Fatal Error! You device not support slot A/B partition, why put Oem_B image into flash tool?
            echo.
            echo. Error: AP flash failed!
            exit /b 1
        )
    )

    REM if %A% EQU 1
    if exist oem_b.img_sparsechunk* (
        echo.
        echo. ------ Flashing sparse Oem_B image ------
        for %%a in (oem_b.img_sparsechunk*) do (
            echo.
            echo. ==^> Flashing sparse Oem image:%%a
            %fastboot% flash oem_b %%a
            if !errorlevel! NEQ 0 (
                color f6
                echo. ------------------------------
                echo. Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
    )
    if exist oem_other.img (
        echo.
        echo. ------ Flashing full Oem_B image ------
        %fastboot% flash oem_b oem_other.img
        if !errorlevel! NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash oem_b failed!
            echo. ------------------------------
        )
    )

    REM This is a discriminant for vendor image.
    set /A A=0
    if exist vendor.img set /A A+=1
    if exist vendor.img_sparsechunk* set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo. Fatal Error: Full and sparse Vendor image exists at the same time, this is obviously wrong, please check!
        echo.
        echo. Error: AP flash failed!
        exit /b 1
    )
    if %A% EQU 0 (
        if "!device_has_vendor!" EQU "1" (
            echo.
            echo. Note: Full or sparse Vendor image does not exist, but your device contain this partition, skipping flash...
        )
    )

    REM if %A% EQU 1
    if exist vendor.img_sparsechunk* (
        echo.
        echo. ------ Flashing sparse Vendor image ------
        set flash_failed=0
        for %%a in (vendor.img_sparsechunk*) do (
            echo.
            echo. ==^> Flashing sparse Vendor image: %%a
            %fastboot% flash vendor %%a
            if !errorlevel! NEQ 0 (
                color fc
                set flash_failed=1
                echo. ------------------------------
                echo. Fatal Error: fastboot flash %%a failed!
                echo. ------------------------------
            )
        )
        if !flash_failed! NEQ 0 (
            echo.
            echo. Error: AP flash failed!
            exit /b 1
        )
    ) else (
        if exist vendor.img (
            echo.
            echo. ------ Flashing full Vendor image ------
            %fastboot% flash vendor vendor.img
            if !errorlevel! NEQ 0 (
                color fc
                echo. ------------------------------
                echo. Fatal Error: fastboot flash vendor failed!
                echo. ------------------------------
                echo.
                echo. Error: AP flash failed!
                exit /b 1
            )
        )
    )
exit /b 0
