@echo off
if exist %~p1enumerateAdbDevices.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:enumerateAdbDevices
    set device_list=
    set device_count=0
    set /A wait_time=1

    call "%~dp0killAdbServer.cmd"

    echo.
    echo. Note: ADB can only be used after the System is started. ADB is not Fastboot, Fastboot is certainly not ADB.
    echo.
    echo. Try to connect ADB device...

    %adb% start-server
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Start ADB Server failed!
        echo.
        goto :exitEnumeration
    )

    :enumerateAdbLoop
    for /F "tokens=2" %%X in ('%adb% devices 2^>^&1 ^| findstr device') do (
        echo.
        echo. Finding ADB device...
        echo.
        ::SET devicesd=%%X
        if "%%X" == "device" (
            set /A device_count+=1
            set device_list=%%X
        )
    )

    if "%device_count%" GEQ "2" (
        color fc
        echo.
        echo. Fatal Error: Multiple devices have been detected, this script does not support multiple devices, please try again!
        echo.
        goto :exitEnumeration
    )

    if "%device_list%" == "" (
        ping 127.0.1 -n 2 >nul 2>nul
        set /A wait_time+=1
        if !wait_time! == 30 (
            color fc
            echo.
            echo. Fatal Error: No device found, please confirm your operation is correct and try again.
            echo.
            goto :exitEnumeration
        )
        goto :enumerateAdbLoop
    )
exit /b 0
::
::
:exitEnumeration
    call "%~dp0killAdbServer.cmd"
    echo.
    echo. Press any key to exit.
    pause > nul
exit
