@echo off
if exist %~p1getDeviceInfo.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:getDeviceInfo
@title %title% %version% - Get device information

    call "%~dp0enumerateFbDevices.cmd"
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo.  A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    REM remove temp file
    del /f /s /q "%~dp0deviceInfo.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    for /F "usebackq tokens=*" %%X in (`%fastboot% getvar all 2^>^&1`) do (
      echo %%X >> "%~dp0deviceInfo.txt"
    )

    echo.
    echo. Fetching...
    echo.
    REM get variables
    set device_sku=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "sku:" ^| %awk% "{print $3}"') do (
        set device_sku=%%C
    )
    set device_product=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "product:" ^| %awk% "{print $3}"') do (
        set device_product=%%C
    )
    set device_serialno=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "serialno:" ^| %awk% "{print $3}"') do (
        set device_serialno=%%C
    )
    set device_cid=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "cid:" ^| %awk% "{print $3}"') do (
        set device_cid=%%C
    )
    set device_date=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "date:" ^| %awk% "{print $3}"') do (
        set device_date=%%C
    )
    set device_secure=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "secure:" ^| %awk% "{print $3}"') do (
        set device_secure=%%C
    )
    set device_imei=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "imei:" ^| %awk% "{print $3}"') do (
        set device_imei=%%C
    )
    set device_cpu=
    for /F "tokens=1 delims=:" %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "cpu:" ^| %awk% "{print $3,$4}"') do (
        set device_cpu=%%C
    )
    set device_ram=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "ram:" ^| %awk% "{print $3}"') do (
        set device_ram=%%C
    )
    set storage_type=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "storage-type:" ^| %awk% "{print $3}"') do (
        set storage_type=%%C
    )
    set device_emmc=
    for /F "tokens=1 delims=:" %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "emmc:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_emmc=%%C
    )
    set device_ufs=
    for /F "tokens=1 delims=:" %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "ufs:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_ufs=%%C
    )
    set device_ram=
    for /F "tokens=1 delims=:" %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "ram:" ^| %awk% -F": " "{print $2,$3}"') do (
        set device_ram=%%C
    )
    set device_radio=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "radio:" ^| %awk% "{print $3}"') do (
        set device_radio=%%C
    )
    set device_channelid=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "channelid:" ^| %awk% "{print $3}"') do (
        set device_channelid=%%C
    )
    set device_uid=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "uid:" ^| %awk% "{print $3}"') do (
        set device_uid=%%C
    )
    set device_unlocked=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "unlocked:" ^| %awk% "{print $3}"') do (
        set device_unlocked=%%C
    )
    set device_version-bootloader=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "version-bootloader:" ^| %awk% "{print $3}"') do (
        set device_version-bootloader=%%C
    )
    set device_securestate=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "securestate:" ^| %awk% "{print $3}"') do (
        set device_securestate=%%C
    )
    set device_mot_sst=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "mot_sst:" ^| %awk% "{print $3}"') do (
        set device_mot_sst=%%C
    )
    set device_ro_carrier=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "ro.carrier:" ^| %awk% "{print $3}"') do (
        set device_ro_carrier=%%C
    )
    set device_slot_count=
    for /F %%C in ('type "%~dp0deviceInfo.txt" ^| %grep% "slot-count:" ^| %awk% "{print $3}"') do (
        set device_slot_count=%%C
    )


    echo.
    echo. ================================================================================
    echo. Some information about your device:
    echo. ================================================================================
    echo. Base Info:
    echo. BootLoader version: %device_version-bootloader%
    if "%device_sku%" NEQ "" (
        echo. SKU model: %device_sku%
    ) else (
        echo. SKU model: Unknown
    )
    if "%device_product%" NEQ "" (
        echo. Product Code: %device_product%
    ) else (
        echo. Product Code: Unknown
    )
    if "%device_serialno%" NEQ "" (
        echo. Serialno: %device_serialno%
    ) else (
        echo. Serialno: Unknown
    )
    if "%device_cid%" NEQ "" (
        echo. ICCID: %device_cid%
    ) else (
        echo. ICCID: Unknown
    )
    if "%device_ro_carrier%" NEQ "" (
        echo. Carrier: %device_ro_carrier%
    ) else (
        echo. Carrier: Unknown
    )
    if "%device_radio%" NEQ "" (
        echo. Radio Code: %device_radio%
    ) else (
        echo. Radio Code: Unknown
    )
    if "%device_channelid%" NEQ "" (
        echo. Channel ID: %device_channelid%
    ) else (
        echo. Channel ID: Unknown
    )
    if "%device_date%" NEQ "" (
        echo. Date of manufacture: %device_date%
    ) else (
        echo. Date of manufacture: Unknown
    )
    if "%device_imei%" NEQ "" (
        echo. IMEI: %device_imei%
    ) else (
        echo. IMEI: Unknown
    )
    if "%device_uid%" NEQ "" (
        echo. UID: %device_uid%
    ) else (
        echo. UID: Unknown
    )
    if "%device_cpu%" NEQ "" (
        echo. CPU model: %device_cpu%
    ) else (
        echo. CPU model: Unknown
    )

    if "%device_ram%" NEQ "" (
        echo. RAM model: %device_ram%
    ) else (
        echo. RAM model: Unknown
    )
    if "%device_ufs%" NEQ "" (
        if "!storage_type!" NEQ "eMMC" (
            echo. Storage type: UFS
            echo. UFS model: %device_ufs%
        )
    )
    if "%device_emmc%" NEQ "" (
        if "!storage_type!" NEQ "UFS" (
            echo. Storage type: eMMC
            echo. eMMC model: %device_emmc%
        )
    )
    if "%device_secure%" NEQ "" (
        if "!device_secure!" EQU "no" (
            echo. Fully unlocked (E.g Engineering Phone): Yes
        ) else (
            echo. Fully unlocked (E.g Engineering Phone): No
        )
    ) else (
        echo. Fully unlocked (E.g Engineering Phone): Unknown
    )
    if "%device_securestate%" NEQ "" (
        echo. Secure State: %device_securestate%
    ) else (
        if "!device_mot_sst!" NEQ "" (
            if "!device_mot_sst!" EQU "0" (
                echo. Secure State: locked
            )
            if "!device_mot_sst!" EQU "1" (
                echo. Secure State: factory_unlocked
            )
            if "!device_mot_sst!" EQU "2" (
                echo. Secure State: locked
            )
            if "!device_mot_sst!" EQU "3" (
                echo. Secure State: unlocked
            )
        ) else (
            if "!device_secure!" NEQ "" (
                echo. Secure State: Unknown
            ) else (
                if "!device_secure!" EQU "yes" (
                    echo. Secure State: locked
                ) else (
                    if "!device_secure!" EQU "no" (
                        echo. Secure State: unlocked
                    ) else (
                        echo. Secure State: Unknown
                    )
                )
                )
            )
        )
    )
    if "%device_unlocked%" NEQ "" (
        if "!device_unlocked!" EQU "Not" (
            echo. Lock State: unlocked
        )
        if "!device_unlocked!" EQU "yes" (
            echo. Lock State: unlocked
        )
        if "!device_unlocked!" EQU "no" (
            echo. Lock State: locked
        )
    ) else (
        if "!device_securestate!" NEQ "" (
            if "!device_securestate!" EQU "flashing_unlocked" (
                echo. Lock State: unlocked
            )
            if "!device_securestate!" EQU "oem_locked" (
                echo. Lock State: locked
            )
        ) else (
            echo. Lock State: Unknown
        )
    )
    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            echo. Support slot A/B partition: Yes
        ) else (
            echo. Support slot A/B partition: No
        )

    ) else (
        echo. Support slot A/B partition: Unknown
    )

    echo. --------------------------------------------------------------------------------
    echo. Security Version Fuse (SV FUSE) Info:

    %fastboot% oem read_sv

    echo. ================================================================================
    REM remove temp file
    del /f /s /q "%~dp0deviceInfo.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo. Press any key to return to the Main menu.
    pause > nul
exit /b 0
::
::
:exit
exit
