@echo off
if exist %~p1getPartitionTable.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:getPartitionTable
    set device_ab_slot=0
    REM remove temp file
    del /f /s /q "%~dp0devicePT.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    REM is device support A/B partition?
    set device_slot_count=0
    for /F "usebackq tokens=*" %%X in (`%fastboot% getvar slot-count 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| findstr slot-count:') do (
            set device_slot_count=%%C
        )
    )

    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            set device_ab_slot=1
            echo. [Debug] Device has slot A/B partition.
        ) else (
            set device_ab_slot=0
            echo. [Debug] Device does not have slot A/B partition.
        )
    ) else (
        echo. [Debug] Device slot info is unknown.
        set device_ab_slot=0
    )

    for /F "usebackq tokens=*" %%X in (`%fastboot% oem partition 2^>^&1`) do (
      echo %%X >> "%~dp0devicePT.txt"
    )

    set slotsuffix=0
    if "%device_ab_slot%" EQU "1"  (
        set slotsuffix=_a:
    ) else (
        set slotsuffix=:
    )

    set cid_tmp=
    set sumposition=0
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "cid:" ^| %awk% "{print $2}" ^| %awk% -F: "{print $1}"') do (
        set cid_tmp=%%C
    )
    if "%cid_tmp%" EQU "lun0"  (
        echo. [Debug] Device has lun.
        set sumposition=3
    ) else (
        echo. [Debug] Device does not have lun.
        set sumposition=2
    )

    set recovery_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "recovery%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set recovery_a_tmp=%%C
    )
    set dtbo_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "dtbo%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set dtbo_a_tmp=%%C
    )
    set vbmeta_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "vbmeta%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set vbmeta_a_tmp=%%C
    )
    set dsp_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "dsp%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set dsp_a_tmp=%%C
    )
    set bluetooth_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "bluetooth%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set bluetooth_a_tmp=%%C
    )
    set oem_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "oem%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set oem_a_tmp=%%C
    )
    set vendor_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "vendor%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set vendor_a_tmp=%%C
    )
    set fsg_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "fsg%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set fsg_a_tmp=%%C
    )
    set carrier_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "carrier:" ^| %awk% "{print $%sumposition%}"') do (
        set carrier_tmp=%%C
    )
    set ddr_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "ddr:" ^| %awk% "{print $%sumposition%}"') do (
        set ddr_tmp=%%C
    )
    set oldddr_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "DDR:" ^| %awk% "{print $%sumposition%}"') do (
        set oldddr_tmp=%%C
    )
    set customize_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "customize:" ^| %awk% "{print $%sumposition%}"') do (
        set customize_tmp=%%C
    )
    set clogo_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "clogo:" ^| %awk% "{print $%sumposition%}"') do (
        set clogo_tmp=%%C
    )
    set modemst_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "modemst1:" ^| %awk% "{print $%sumposition%}"') do (
        set modemst_tmp=%%C
    )

    REM SLSI related partition
    set ldfw_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "ldfw%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set ldfw_a_tmp=%%C
    )
    set keystorage_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "keystorage%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set keystorage_a_tmp=%%C
    )
    set fwbl1_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "fwbl1:" ^| %awk% "{print $%sumposition%}"') do (
        set fwbl1_tmp=%%C
    )

    REM MTK related partition
    set lk_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "lk%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set lk_a_tmp=%%C
    )
    set tee_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "tee%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set tee_a_tmp=%%C
    )
    set md1img_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "md1img%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set md1img_a_tmp=%%C
    )
    set spmfw_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "spmfw%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set spmfw_a_tmp=%%C
    )
    set scp_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "scp%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set scp_a_tmp=%%C
    )
    set sspm_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "sspm%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set sspm_a_tmp=%%C
    )
    set cam_vpu1_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "cam_vpu1%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set cam_vpu1_a_tmp=%%C
    )
    set dtb_a_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "dtb%slotsuffix%" ^| %awk% "{print $%sumposition%}"') do (
        set dtb_a_tmp=%%C
    )
    set preloader_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "preloader:" ^| %awk% "{print $%sumposition%}"') do (
        set preloader_tmp=%%C
    )
    set nvdata_tmp=
    for /F %%C in ('type "%~dp0devicePT.txt" ^| %grep% "nvdata:" ^| %awk% "{print $%sumposition%}"') do (
        set nvdata_tmp=%%C
    )

    if "%recovery_a_tmp%" EQU "recovery%slotsuffix%" (
        set device_has_recovery=1
    ) else (
        set device_has_recovery=0
    )
    if "%dtbo_a_tmp%" EQU "dtbo%slotsuffix%" (
        set device_has_dtbo=1
    ) else (
        set device_has_dtbo=0
    )
    if "%vbmeta_a_tmp%" EQU "vbmeta%slotsuffix%" (
        set device_has_vbmeta=1
    ) else (
        set device_has_vbmeta=0
    )
    if "%dsp_a_tmp%" EQU "dsp%slotsuffix%" (
        set device_has_dsp=1
    ) else (
        set device_has_dsp=0
    )
    if "%bluetooth_a_tmp%" EQU "bluetooth%slotsuffix%" (
        set device_has_bluetooth=1
    ) else (
        set device_has_bluetooth=0
    )
    if "%oem_a_tmp%" EQU "oem%slotsuffix%" (
        set device_has_oem=1
    ) else (
        set device_has_oem=0
    )
    if "%vendor_a_tmp%" EQU "vendor%slotsuffix%" (
        set device_has_vendor=1
    ) else (
        set device_has_vendor=0
    )
    if "%fsg_a_tmp%" EQU "fsg%slotsuffix%" (
        set device_has_fsg=1
    ) else (
        set device_has_fsg=0
    )
    if "%carrier_tmp%" EQU "carrier:" (
        set device_has_carrier=1
    ) else (
        set device_has_carrier=0
    )
    if "%ddr_tmp%" EQU "ddr:" (
        set device_has_ddr=1
    ) else (
        set device_has_ddr=0
    )
    if "%oldddr_tmp%" EQU "DDR:" (
        set device_has_oldddr=1
    ) else (
        set device_has_oldddr=0
    )
    if "%customize_tmp%" EQU "customize:" (
        set device_has_customize=1
    ) else (
        set device_has_customize=0
    )
    if "%clogo_tmp%" EQU "clogo:" (
        set device_has_clogo=1
    ) else (
        set device_has_clogo=0
    )
    if "%modemst_tmp%" EQU "modemst1:" (
        set device_has_modemst=1
    ) else (
        set device_has_modemst=0
    )
    REM SLSI
    if "%ldfw_a_tmp%" EQU "ldfw%slotsuffix%" (
        set device_has_ldfw=1
    ) else (
        set device_has_ldfw=0
    )
    if "%keystorage_a_tmp%" EQU "keystorage%slotsuffix%" (
        set device_has_keystorage=1
    ) else (
        set device_has_keystorage=0
    )
    if "%fwbl1_tmp%" EQU "fwbl1:" (
        set device_has_fwbl1=1
    ) else (
        set device_has_fwbl1=0
    )
    REM MTK
    if "%preloader_tmp%" EQU "preloader:" (
        set device_has_perloader=1
    ) else (
        set device_has_perloader=0
    )
    if "%nvdata_tmp%" EQU "nvdata:" (
        set device_has_nvdata=1
    ) else (
        set device_has_nvdata=0
    )
    if "%lk_a_tmp%" EQU "lk%slotsuffix%" (
        set device_has_lk=1
    ) else (
        set device_has_lk=0
    )
    if "%tee_a_tmp%" EQU "tee%slotsuffix%" (
        set device_has_tee=1
    ) else (
        set device_has_tee=0
    )
    if "%md1img_a_tmp%" EQU "md1img%slotsuffix%" (
        set device_has_md1img=1
    ) else (
        set device_has_md1img=0
    )
    if "%spmfw_a_tmp%" EQU "spmfw%slotsuffix%" (
        set device_has_spmfw=1
    ) else (
        set device_has_spmfw=0
    )
    if "%scp_a_tmp%" EQU "scp%slotsuffix%" (
        set device_has_scp=1
    ) else (
        set device_has_scp=0
    )
    if "%sspm_a_tmp%" EQU "sspm%slotsuffix%" (
        set device_has_sspm=1
    ) else (
        set device_has_sspm=0
    )
    if "%cam_vpu1_a_tmp%" EQU "cam_vpu1%slotsuffix%" (
        set device_has_cam_vpu1=1
    ) else (
        set device_has_cam_vpu1=0
    )
    if "%dtb_a_tmp%" EQU "dtb%slotsuffix%" (
        set device_has_dtb=1
    ) else (
        set device_has_dtb=0
    )

    REM remove temp file
    del /f /s /q "%~dp0devicePT.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
exit /b 0
::
::
:exit
exit
