@echo off
if exist %~p1smartFlash.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:smartFlash
    set is_recovery_img=0
    for /f "delims=" %%i in ('echo "%file%" 2^>^&1') do (
        echo %%i 2^>^&1 | find "twrp-" >nul && set is_recovery_img=1
        echo %%i 2^>^&1 | find "recovery." >nul && set is_recovery_img=1
    )
    if "%is_recovery_img%" == "1" (
        call :smartFlashRecovery
    ) else (
        call :smartFlashOthers
    )
goto :smartEnd

:smartFlashRecovery
@title %title% %version% - Flash Recovery
    echo. ================================================================================
    echo.                                          Please choose:
    echo. ================================================================================
    echo.
    echo. [1] Direct boot recovery. Suitable for slot A/B partition devices without real Recovery partitions from 2017 to 2020.
    echo. [2] Flash real Recovery partition. Suitable for devices with real Recovery partition.
    echo. [0] Exit flash tool
    echo. --------------------------------------------------------------------------------
    echo.
    set selection=
    set /p selection= Please enter the option number: ^>^>
        if /i "%selection%"=="1" cls && goto :bootToRecoveryOnetime
        if /i "%selection%"=="2" cls && goto :flashRecoveryPartition
        if /i "%selection%"=="0" cls && exit /b 0

    cls && goto :smartFlashRecovery

    :flashRecoveryPartition

        call "%~dp0enumerateFbDevices.cmd"

        echo.
        echo. ==^> Setting FB mode...
        %fastboot% oem fb_mode_set

        echo.
        echo. ------ Flashing Recovery image ------
        echo.

        %fastboot% flash recovery %file%
        if %errorlevel% NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot flash %file% failed!
            echo. ------------------------------
            echo.
            echo. Please check the reason.
            echo.
            echo. Press any key to exit...
            pause >nul 2>nul
            goto :exit
        )
        echo.
        echo. ==^> Clean FB mode...
        %fastboot% oem fb_mode_clear
        color f2
        echo.
        echo. Operation completed.
        ping 127.0.1 -n 3 >nul 2>nul
        goto :smartEnd
    exit /b 0
    ::
    ::
    :bootToRecoveryOnetime

        call "%~dp0enumerateFbDevices.cmd"

        echo.
        echo. ------ Direct boot Recovery image ------
        %fastboot% boot %file%
        if %errorlevel% NEQ 0 (
            color f6
            echo. ------------------------------
            echo. Error: fastboot boot %file% failed!
            echo. ------------------------------
            echo.
            echo. Please check the reason.
            echo.
            echo. Press any key to exit...
            pause >nul 2>nul
            goto :exit
        )
        color f2
        echo.
        echo. Operation completed.
        ping 127.0.1 -n 3 >nul 2>nul
        goto :smartEnd
    exit /b 0
::
::
:smartFlashOthers

    call "%~dp0enumerateFbDevices.cmd"

    echo.
    echo. Flashing %file%
    if "%file%" == "logo.bin" call %fastboot% flash logo %file% && goto :smartEnd
    if "%file%" == "boot.img" call %fastboot% flash boot %file% && goto :smartEnd
    if "%file%" == "dtb.img" call %fastboot% flash dtb %file% && goto :smartEnd
    if "%file%" == "dtbo.img" call %fastboot% flash dtbo %file% && goto :smartEnd
    if "%file%" == "vbmeta.img" call %fastboot% flash vbmeta %file% && goto :smartEnd
    if "%file%" == "system.img" call %fastboot% flash system %file% && goto :smartEnd
    if "%file%" == "super.img" call %fastboot% flash super %file% && goto :smartEnd
    if "%file%" == "NON-HLOS.bin" call %fastboot% flash modem %file% && goto :smartEnd
    if "%file%" == "radio.img" call %fastboot% flash radio %file% && goto :smartEnd
    if "%file%" == "fsg.mbn" call %fastboot% flash fsg %file% && goto :smartEnd
    if "%file%" == "BTFM.bin" call %fastboot% flash bluetooth %file% && goto :smartEnd
    if "%file%" == "gpt.bin" call %fastboot% flash partition %file% && goto :smartEnd
    if "%file%" == "motoboot.img" call %fastboot% flash motoboot %file% && goto :smartEnd
    if "%file%" == "bootloader.img" call %fastboot% flash bootloader %file% && goto :smartEnd
    if "%file%" == "userdata.img" call %fastboot% flash userdata %file% && goto :smartEnd
    if "%file%" == "cache.img" call %fastboot% flash cache %file% && goto :smartEnd
    if "%file%" == "customize.img" call %fastboot% flash customize %file% && goto :smartEnd
    if "%file%" == "adspso.bin" call %fastboot% flash dsp %file% && goto :smartEnd
    if "%file%" == "dspso.bin" call %fastboot% flash dsp %file% && goto :smartEnd
    if "%file%" == "oem.img" call %fastboot% flash oem %file% && goto :smartEnd
    if "%file%" == "oem_other.img" call %fastboot% flash oem_b %file% && goto :smartEnd

    echo. Error: %file% seems is not a flashable image.
    goto :smartEnd
exit /b 0
::
::
:smartEnd
    echo.
    echo. Exiting...
    ping 127.1 -n 5 > nul 2>nul
goto :exit
::
::
:exit
exit
