@echo off
if exist %~p1unlockBLMenu.cmd color 40 && echo. && echo. && echo. Error! Please do not execute this file alone! && echo. && echo. Please press any key to exit. && pause>nul && exit

:unlockBLMenu
@title %title% %version% - Bootloader Unlock Menu
color f9
    echo. --------------------------------------------------------------------------------
    echo. [1] Unlock Bootloader for Google devices 
    echo. [2] Unlock Bootloader for Motorola devices (Unlock code required)
    echo. [3] Get unlock data
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo. --------------------------------------------------------------------------------
    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && call :unlockBL1
        if "%input%"=="2" cls && call :unlockBL2
        if "%input%"=="3" cls && call :getUnlockData
        if "%input%"=="0" cls && exit /b 0
    cls
goto :unlockBLMenu
::
::
:unlockBL1
@title %title% %version% - Bootloader Unlock Menu ( Nexus/Pixel devices )
    echo. ================================================================================
    echo.                                          NOTE:
    echo. ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo.
    echo. [*] Please press the volume key, move to the "YES" option, and then press the power button to confirm unlock BL.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. Please press any key to continue, or click the  button in the upper right corner to exit.
    pause > nul

    call "%~dp0enumerateFbDevices.cmd"

    echo.
    echo. Executing: fastboot oem unlock
    %fastboot% oem unlock
    if %errorlevel% NEQ 0 (
        color f6
        echo. ---------------------------
        echo. Error: Operation failed!
        echo. ---------------------------
        echo.
        echo. Press any key to return.
        pause > nul
    ) else (
        color f2
        echo.
        echo. Operation completed.
        ping 127.1 -n 3 > nul 2>nul
    )
    exit /b 0
::
::
:unlockBL2
@title %title% %version% - BootLoader Unlock Menu ( Motorola devices )
    echo. ================================================================================
    echo.                                      NOTE:
    echo. ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo. --------------------------------------------------------------------------------
    echo.
    echo. [-] Note: Please enter unlock code and press Enter.
    echo. [-] Eg. DVNJ6NFFT2MLEZABQ4FQ
    echo.
    set unlockcode=
    set /p unlockcode= Please enter the unlock code: ^>^>
        if "%unlockcode%"=="" (
            echo. Input error, please try again.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :unlockBL2
        )

    call "%~dp0enumerateFbDevices.cmd"

    echo.
    echo. Executing: fastboot oem unlock %unlockcode%
    %fastboot% oem unlock %unlockcode%
    REM Confirm unlock again
    %fastboot% oem unlock %unlockcode%
    if %errorlevel% NEQ 0 (
        color f6
        echo. ---------------------------
        echo. Error: Operation failed!
        echo. ---------------------------
    ) else (
        color f2
        echo.
        echo. Operation completed.
    )
    echo.
    echo. Press any key to return.
    pause > nul
exit /b 0
::
::
:getUnlockData
@title %title% %version% - BootLoader Unlock Menu ( Get unlock data )
    echo.--------------------------------------------------------------------------------
    echo. Unlocking steps:
    echo. [*] 1. Open Motorola Unlocking the bootloader website, then login Motorola or Google account;
    echo. [*] 2. Enter unlock data to input box, and click "Can my device be unlocked" button;
    echo. [*] 3. If your device can be unlocked, Click "Request Unlock Key" button.
    echo. When finished, unlock code will be sent to your mailbox.
    echo.
    echo. [*] NOTE: some US carriers, Eg. Verizon / AT&T, can't be unlock Bootloader,
    echo. Website will alert you "Your device does not qualify for bootloader unlocking".
    echo.
    echo. [1] Open Motorola Unlocking the bootloader website
    echo. [2] ^<^< Return to the BootLoader Unlock menu
    echo. [0] ^<^<^< Return to the Main menu
    echo. --------------------------------------------------------------------------------

    call "%~dp0enumerateFbDevices.cmd"

    del /f /s /q "%~dp0ULKData.txt" "%~dp0ULKData2.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo. Fetching...
    for /F "usebackq tokens=*" %%X in (`%fastboot% oem get_unlock_data 2^>^&1`) do (
      echo %%X >> "%~dp0ULKData.txt"
    )

    %sed% "/^ECHO /"d "%~dp0ULKData.txt" > "%~dp0ULKData2.txt"
    %sed% "/(bootloader) slot/"d "%~dp0ULKData2.txt" > "%~dp0ULKData.txt"
    %sed% "/^\.\.\./"d "%~dp0ULKData.txt" > "%~dp0ULKData2.txt"
    %sed% "/Unlock data:/"d "%~dp0ULKData2.txt" > "%~dp0ULKData.txt"
    %sed% "/^OKAY \[/"d "%~dp0ULKData.txt" > "%~dp0ULKData2.txt"
    %sed% "/^finished/"d "%~dp0ULKData2.txt" > "%~dp0ULKData.txt"
    %sed% "/^Finished/"d "%~dp0ULKData.txt" > "%~dp0ULKData2.txt"
    %sed% "s/(bootloader) //g" "%~dp0ULKData2.txt" > "%~dp0ULKData.txt"
    %sed% "s/ *$//" "%~dp0ULKData.txt" > "%~dp0ULKData2.txt"
    %sed% ":a;N;s/\n//g;ba" "%~dp0ULKData2.txt" > "%~dp0ULKData.txt"
    %awk% "{printf \"%%s\",$0}" %~dp0ULKData.txt > "%~dp0ULKData2.txt"

    echo.
    echo. Your device's unlock data:
    echo.
    type "%~dp0ULKData2.txt"
    clip < "%~dp0ULKData2.txt"
    echo.
    echo.
    echo. Unlock data has been pasted to the clipboard.
    echo.

    del /f /s /q "%~dp0ULKData.txt" "%~dp0ULKData2.txt" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. A fatal error occurred, exiting...
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && start "" "https://motorola-global-portal.custhelp.com/app/standalone/bootloader/unlock-your-device-b" >nul 2>nul && goto :getUnlockData
        if "%input%"=="2" cls && exit /b 0
        if "%input%"=="0" cls && exit /b 0 && exit /b 0
    ping 127.0.1 -n 2 >nul 2>nul
    cls
goto :getUnlockData
::
::
:exit
exit
